<script setup lang="ts">
import { ref, reactive, onMounted } from "vue";
import { useQuasar, type QTableColumn } from "quasar";
import axios from "axios";

import { useRoute } from "vue-router";
import { checkPermission } from "@/utils/permissions";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";

import type { RequestItemsObject } from "@/modules/04_registryPerson/interface/index/performSpecialWork";
import type { ResFileData } from "@/modules/04_registryPerson/interface/index/Main";

import DialogHeader from "@/components/DialogHeader.vue";
import DialogHistory from "@/modules/04_registryPerson/components/detail/DialogHistory.vue";

// import DialogHistory from "@/modules/04_registryPerson/components/detail/GovernmentInformation/04_PerformSpecialWorkHistory.vue";

const route = useRoute();

const $q = useQuasar();
const mixin = useCounterMixin();
const {
  date2Thai,
  dialogConfirm,
  messageError,
  showLoader,
  hideLoader,
  success,
  pathRegistryEmp,
  onSearchDataTable,
  convertDateToAPI,
  dialogRemove,
} = mixin;

const profileId = ref<string>(
  route.params.id ? route.params.id.toString() : ""
);
const empType = ref<string>(pathRegistryEmp(route.name?.toString() ?? ""));

const uploadUrl = ref<string>("");

const isUpload = ref<boolean>(false);
const fileUpload = ref<File | null>(null);
const fileData = ref<ResFileData | null>(null);

/** props*/
const isLeave = defineModel<boolean>("isLeave", {
  required: true,
});
const id = ref<string>(""); //id ที่ต้องการแก้ไข
const modal = ref<boolean>(false); //แสดง popup ข้อมูลปฏิบัติราชการพิเศษ
const modalHistory = ref<boolean>(false); //แสดง popup ประวัติการแก้ไขข้อมูลปฏิบัติราชการพิเศษ
const edit = ref<boolean>(false); //สถานะการแก้ไข
//ฟอร์มข้อมูลปฏิบัติราชการพิเศษ
const dutyData = reactive<RequestItemsObject>({
  profileId: profileId.value,
  dateStart: new Date(), //วันที่เริ่มต้น
  dateEnd: null, //วันที่สิ้นสุด
  detail: "", //รายละเอียด
  reference: "", //เอกสารอ้างอิง
  refCommandNo: "", //เลขที่คำสั่ง
  refCommandDate: null, //'เอกสารอ้างอิง (ลงวันที่)',
  isUpload: false,
});

const baseColumns = ref<QTableColumn[]>([
  {
    name: "dateStart",
    align: "left",
    label: "เริ่มต้น",
    sortable: true,
    field: "dateStart",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateEnd",
    align: "left",
    label: "สิ้นสุด",
    sortable: true,
    field: "dateEnd",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "reference",
    align: "left",
    label: "เอกสารอ้างอิง",
    sortable: true,
    field: "reference",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandNo",
    align: "left",
    label: "เลขที่คำสั่ง",
    sortable: true,
    field: "refCommandNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "refCommandDate",
    align: "left",
    label: "เอกสารอ้างอิง (ลงวันที่)",
    sortable: true,
    field: "refCommandDate",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v, false, true),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const baseVisibleColumns = ref<string[]>([
  "dateStart",
  "dateEnd",
  "detail",
  "reference",
  "refCommandNo",
  "refCommandDate",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);

const mode = ref<string>("table"); //การแสดงผล Table card
const filterKeyword = ref<string>(""); //คำค้นหา
const rows = ref<RequestItemsObject[]>([]); //รายการปฏิบัติราชการพิเศษ
const rowsMain = ref<RequestItemsObject[]>([]); //รายการปฏิบัติราชการพิเศษ
const columns = ref<QTableColumn[]>(
  baseColumns.value.filter((e: QTableColumn) => e.name !== "lastUpdateFullName")
);
const visibleColumns = ref<String[]>(
  baseVisibleColumns.value.filter((e: string) => e !== "lastUpdateFullName")
);
const pagination = ref({
  sortBy: "lastUpdatedAt",
});

const columnsHistory = ref<QTableColumn[]>(baseColumns.value);
const visibleColumnsHistory = ref<string[]>(baseVisibleColumns.value);

/** fetch ข้อมูลรายการพิเศษ*/
async function fetchData(id: string) {
  showLoader();
  await http
    .get(config.API.profileNewDutyByProfileId(id, empType.value))
    .then(async (res) => {
      rowsMain.value = await res.data.result;
      serchDataTable();
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** function fetch ข้อมูลประวติการแก้ไขข้อมูล*/
async function fetchDataHistory() {
  showLoader();
  try {
    const res = await http.get(
      config.API.profileNewDutyHisByDutyId(id.value, empType.value)
    );
    const data = res.data.result;
    return data;
  } catch (err) {
    messageError($q, err);
  } finally {
    hideLoader();
  }
}

/** เปิด dialog */
function openDialogAdd() {
  modal.value = true;
}

/** กดแก้ไข  */
function openDialogEdit(props: RequestItemsObject) {
  modal.value = true;
  edit.value = true;
  id.value = props.id ? props.id : "";
  dutyData.dateStart = props.dateStart;
  dutyData.dateEnd = props.dateEnd;
  dutyData.detail = props.detail;
  dutyData.reference = props.reference;
  dutyData.refCommandNo = props.refCommandNo;
  dutyData.refCommandDate = props.refCommandDate;

  isUpload.value = props.isUpload;

  if (isUpload.value && props.id) {
    onDownloadFile(props.id, false);
  }
}

/**
 * ฟังชั้นดูข้อมูลประวัติแก้ไขข้อมูลที่เลือก
 * @param row ข้อมูล row ที่ดูประวัติการแก้ไข
 */
function openDialogHistory(idOrder: string) {
  modalHistory.value = true;
  id.value = idOrder;
}

/** ปิด dialog */
function closeDialog() {
  modal.value = false;
  edit.value = false;
  dutyData.dateStart = new Date();
  dutyData.dateEnd = null;
  dutyData.detail = "";
  dutyData.reference = "";
  dutyData.refCommandNo = "";
  dutyData.refCommandDate = null;
  fileUpload.value = null;
  fileUpload.value = null;
  isUpload.value = false;
  fileData.value = null;
}

/** ยืนยันการบันทึกข้อมูล*/
function onSubmit() {
  dialogConfirm(
    $q,
    () => {
      edit.value ? editData(id.value) : addData();
    },
    "ยืนยันการบันทึกข้อมูล",
    "ต้องการยืนยันการบันทึกข้อมูลนี้หรือไม่ ?"
  );
}

/** functoin บันทึกการเพิ่มข้อมูล*/
function addData() {
  showLoader();
  const body = {
    profileId: empType.value === "" ? profileId.value : undefined,
    profileEmployeeId: empType.value !== "" ? profileId.value : undefined,
    dateStart: convertDateToAPI(dutyData.dateStart),
    dateEnd: convertDateToAPI(dutyData.dateEnd),
    detail: dutyData.detail,
    reference: dutyData.reference,
    refCommandNo: dutyData.refCommandNo,
    refCommandDate: convertDateToAPI(dutyData.refCommandDate),
  };
  http
    .post(config.API.profileNewDuty(empType.value), body)
    .then(async (res) => {
      if (fileUpload.value && res.data.result) {
        await uploadProfile(res.data.result);
      }
      await fetchData(profileId.value);
      await success($q, "บันทึกข้อมูลสำเร็จ");
      closeDialog();
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/** functoin บันทึกการแก้ไขข้อมูล*/
function editData(idData: string) {
  showLoader();
  http
    .patch(config.API.profileNewDutyByDutyId(idData, empType.value), {
      ...dutyData,
      dateStart: convertDateToAPI(dutyData.dateStart),
      dateEnd: convertDateToAPI(dutyData.dateEnd),
      refCommandDate: convertDateToAPI(dutyData.refCommandDate),
      profileId: undefined,
      isUpload: !edit.value ? undefined : isUpload.value,
    })
    .then(async () => {
      if (fileUpload.value && idData) {
        await uploadProfile(idData);
      }
      await fetchData(profileId.value);
      await success($q, "บันทึกข้อมูลสำเร็จ");
      closeDialog();
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันส้ราง Path อัปโหลดไฟล์
 * @param id
 */
async function uploadProfile(id: string) {
  await http
    .post(
      config.API.subFile(
        "ทะเบียนประวัติ",
        "เอกสารปฏิบัติราชการพิเศษ",
        profileId.value,
        id
      ),
      {
        replace: true,
        fileList: [
          {
            fileName: "เอกสารหลักฐาน",
          },
        ],
      }
    )
    .then(async (res) => {
      uploadUrl.value = res.data["เอกสารหลักฐาน"].uploadUrl;
      await uploadFileURL(uploadUrl.value, fileUpload.value, id);
    })
    .catch((err) => {
      messageError($q, err);
    });
}

/**
 * ฟังก์ชันอัปโหลดำไฟล์
 * @param uploadUrl Path อัปโหลดไฟล์
 * @param file ไฟล์เอกสาร
 */
async function uploadFileURL(uploadUrl: string, file: any, id: string) {
  await axios
    .put(uploadUrl, file, {
      headers: {
        "Content-Type": file.type,
      },
    })
    .then(async (res) => {
      if (res.status == 200) {
        await isUploadFn(id);
      }
      fileUpload.value = null;
    })
    .catch((err) => {
      messageError($q, err);
    });
}

async function isUploadFn(id: string) {
  await http
    .patch(config.API.profileNewDutyByDutyId(id, empType.value), {
      isUpload: fileUpload.value ? true : false,
    })
    .then(async (res) => {})

    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * ฟังก์ชันโหลไฟลเอกสารหลักฐาน
 * @param id รายการที่ต้องการโหลด
 */
async function onDownloadFile(id: string, isLoad: boolean = true) {
  showLoader();
  await http
    .get(
      config.API.subFileByFileName(
        "ทะเบียนประวัติ",
        "เอกสารปฏิบัติราชการพิเศษ",
        profileId.value,
        id,
        "เอกสารหลักฐาน"
      )
    )
    .then(async (res) => {
      const data = res.data;
      fileData.value = data;
      if (isLoad) {
        window.open(data.downloadUrl, "_blank");
      }
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

function serchDataTable() {
  rows.value = onSearchDataTable(
    filterKeyword.value,
    rowsMain.value,
    columns.value ? columns.value : []
  );
}

function handleDelete(id: string) {
  dialogRemove($q, async () => {
    showLoader();
    try {
      await http.patch(
        config.API.profileDutyUpdateDelete(empType.value) + `${id}`
      );
      await fetchData(profileId.value);

      success($q, "ลบข้อมูลสำเร็จ");
    } catch (err) {
      messageError($q, err);
    } finally {
      hideLoader();
    }
  });
}

/** ทำงานเมื่อ Components ถูกเรียกใช้งา*/
onMounted(() => {
  fetchData(profileId.value);
});
</script>

<template>
  <div class="row items-center q-gutter-x-sm q-pb-sm">
    <q-btn
      v-if="isLeave == false && checkPermission($route)?.attrIsUpdate"
      dense
      color="primary"
      icon="add"
      flat
      round
      @click="openDialogAdd()"
      ><q-tooltip>เพิ่มข้อมูล</q-tooltip></q-btn
    >

    <q-space />
    <q-input
      standout
      dense
      v-model="filterKeyword"
      ref="filterRef"
      outlined
      placeholder="ค้นหา"
      @keydown.enter.prevent="serchDataTable"
    >
      <template v-slot:append>
        <q-icon name="search" />
      </template>
    </q-input>
    <q-select
      v-model="visibleColumns"
      multiple
      outlined
      dense
      options-dense
      :display-value="$q.lang.table.columns"
      emit-value
      map-options
      :options="columns"
      option-value="name"
      style="min-width: 140px"
    />
    <q-btn-toggle
      v-model="mode"
      dense
      class="no-shadow toggle-borderd"
      toggle-color="grey-4"
      :options="[
        { value: 'table', slot: 'table' },
        { value: 'card', slot: 'card' },
      ]"
    >
      <template v-slot:table>
        <q-icon
          name="format_list_bulleted"
          size="24px"
          :style="{
            color: mode === 'table' ? '#787B7C' : '#C9D3DB',
          }"
        />
      </template>

      <template v-slot:card>
        <q-icon
          name="mdi-view-grid-outline"
          size="24px"
          :style="{
            color: mode === 'card' ? '#787B7C' : '#C9D3DB',
          }"
        />
      </template>
    </q-btn-toggle>
  </div>

  <d-table
    ref="table"
    flat
    bordered
    dense
    :columns="columns"
    :rows="rows"
    :grid="mode === 'card'"
    :visible-columns="visibleColumns"
    v-model:pagination="pagination"
  >
    >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th auto-width></q-th>
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
        <q-th auto-width />
      </q-tr>
    </template>
    <template v-slot:body="props" v-if="mode === 'table'">
      <q-tr :props="props">
        <q-td auto-width>
          <q-btn
            flat
            dense
            round
            color="deep-purple"
            icon="mdi-history"
            @click="openDialogHistory(props.row.id)"
          >
            <q-tooltip>ประวัติแก้ไขปฏิบัติราชการพิเศษ</q-tooltip>
          </q-btn>
          <q-btn
            v-if="isLeave == false && checkPermission($route)?.attrIsUpdate"
            flat
            dense
            round
            color="edit"
            icon="edit"
            clickable
            @click="openDialogEdit(props.row)"
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            v-if="!isLeave && checkPermission($route)?.attrIsDelete"
            color="red"
            flat
            dense
            round
            icon="delete"
            @click="handleDelete(props.row.id)"
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn>
        </q-td>
        <q-td
          v-for="col in props.cols"
          :key="col.id"
          :class="props.row.isEntry ? 'text-grey' : ''"
        >
          <div>
            {{ col.value ? col.value : "-" }}
          </div>
        </q-td>
        <q-td auto-width>
          <q-btn
            v-if="props.row.isUpload == true"
            color="green"
            flat
            dense
            round
            icon="mdi-file-document-outline"
            @click="onDownloadFile(props.row.id)"
          >
            <q-tooltip>ดาวน์โหลด</q-tooltip>
          </q-btn>
        </q-td>
      </q-tr>
    </template>
    <template v-slot:item="props" v-else>
      <div class="q-pa-xs col-xs-12 col-sm-4 col-md-3">
        <q-card flat bordered>
          <q-card-actions align="right" class="bg-grey-3">
            <q-btn
              v-if="props.row.isUpload == true"
              color="green"
              flat
              dense
              round
              icon="mdi-file-document-outline"
              @click="onDownloadFile(props.row.id)"
            >
              <q-tooltip>ดาวน์โหลด</q-tooltip>
            </q-btn>
            <q-btn
              color="deep-purple"
              icon="mdi-history"
              flat
              round
              @click="openDialogHistory(props.row.id)"
            >
              <q-tooltip>ประวัติแก้ไขปฏิบัติราชการพิเศษ</q-tooltip>
            </q-btn>
            <q-btn
              v-if="isLeave == false && checkPermission($route)?.attrIsUpdate"
              color="edit"
              icon="edit"
              flat
              round
              @click="openDialogEdit(props.row)"
            >
              <q-tooltip>แก้ไขข้อมูล</q-tooltip>
            </q-btn>
            <q-btn
              v-if="!isLeave && checkPermission($route)?.attrIsDelete"
              color="red"
              flat
              dense
              round
              icon="delete"
              @click="handleDelete(props.row.id)"
            >
              <q-tooltip>ลบข้อมูล</q-tooltip>
            </q-btn>
          </q-card-actions>

          <q-separator />
          <q-list>
            <div
              :class="`row q-pa-sm`"
              :style="`background-color: ${index % 2 !== 0 ? '#FAFAFA' : ''}`"
              v-for="(col, index) in props.cols"
              :key="col.name"
            >
              <div class="col text-grey-6">
                <div>{{ col.label }}</div>
              </div>
              <div class="col">
                <div>{{ col.value ? col.value : "-" }}</div>
              </div>
            </div>
          </q-list>
        </q-card>
      </div>
    </template>
  </d-table>

  <q-dialog v-model="modal" persistent>
    <q-card>
      <q-form @submit.prevent greedy @validation-success="onSubmit()">
        <DialogHeader
          :tittle="
            edit
              ? 'แก้ไขข้อมูลปฏิบัติราชการพิเศษ'
              : 'เพิ่มข้อมูลปฏิบัติราชการพิเศษ'
          "
          :close="closeDialog"
        />
        <q-separator />
        <q-card-section>
          <div class="row col-12 q-col-gutter-x-xs q-col-gutter-y-xs">
            <div class="col-xs-6 col-sm-6 col-md-6">
              <datepicker
                menu-class-name="modalfix"
                v-model="dutyData.dateStart"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                week-start="0"
                :max-date="dutyData.dateEnd"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    ref="dateStartRef"
                    class="full-width inputgreen cursor-pointer"
                    outlined
                    dense
                    :model-value="date2Thai(dutyData.dateStart)"
                    :rules="[(val:string) => !!val || `${'กรุณาเลือกวันที่เริ่มต้น'}`]"
                    hide-bottom-space
                    :label="`${'วันที่เริ่มต้น'}`"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        color="primary"
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <datepicker
                menu-class-name="modalfix"
                v-model="dutyData.dateEnd"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                :min-date="dutyData.dateStart"
                :readonly="!dutyData.dateStart"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    ref="dateEndRef"
                    :readonly="!dutyData.dateStart"
                    class="full-width inputgreen cursor-pointer"
                    dense
                    outlined
                    :model-value="date2Thai(dutyData.dateEnd)"
                    :rules="[(val:string) => !!val || `${'กรุณาเลือกวันที่สิ้นสุด'}`]"
                    hide-bottom-space
                    :label="`${'วันที่สิ้นสุด'}`"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        color="primary"
                      >
                      </q-icon>
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
            <div class="col-12">
              <q-input
                ref="referenceRef"
                class="full-width inputgreen cursor-pointer"
                outlined
                dense
                lazy-rules
                autogrow
                v-model="dutyData.reference"
                :rules="[(val:string) => !!val || `${'กรุณากรอกเอกสารอ้างอิง'}`]"
                hide-bottom-space
                :label="`${'เอกสารอ้างอิง'}`"
              />
            </div>
            <div class="col-12">
              <q-input
                ref="detailRef"
                class="full-width inputgreen cursor-pointer"
                outlined
                dense
                lazy-rules
                autogrow
                v-model="dutyData.detail"
                :rules="[(val:string) => !!val || `${'กรุณากรอกรายละเอียด'}`]"
                hide-bottom-space
                :label="`${'รายละเอียด'}`"
              />
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <q-input
                class="full-width inputgreen cursor-pointer"
                outlined
                dense
                v-model="dutyData.refCommandNo"
                :label="`${'เลขที่คำสั่ง'}`"
              >
                <template v-slot:append>
                  <q-icon name="mdi-file" class="cursor-pointer" />
                </template>
              </q-input>
            </div>
            <div class="col-xs-6 col-sm-6 col-md-6">
              <datepicker
                menu-class-name="modalfix"
                v-model="dutyData.refCommandDate"
                :locale="'th'"
                autoApply
                :enableTimePicker="false"
                week-start="0"
              >
                <template #year="{ year }">{{ year + 543 }}</template>
                <template #year-overlay-value="{ value }">{{
                  parseInt(value + 543)
                }}</template>
                <template #trigger>
                  <q-input
                    class="full-width inputgreen cursor-pointer"
                    outlined
                    dense
                    lazy-rules
                    :borderless="!edit"
                    :model-value="
                    dutyData.refCommandDate == null ? null : date2Thai(dutyData.refCommandDate as Date)
                  "
                    hide-bottom-space
                    :label="`${'เอกสารอ้างอิง (ลงวันที่)'}`"
                    clearable
                    @clear="dutyData.refCommandDate = null"
                  >
                    <template v-slot:prepend>
                      <q-icon
                        name="event"
                        class="cursor-pointer"
                        color="primary"
                      >
                      </q-icon>
                    </template>
                    <template
                      v-if="dutyData.refCommandDate && edit"
                      v-slot:append
                    >
                    </template>
                  </q-input>
                </template>
              </datepicker>
            </div>
            <div class="col-xs-12 col-sm-12 col-md-12">
              <div class="row">
                <q-uploader
                  v-if="!isUpload"
                  color="gray"
                  type="file"
                  flat
                  ref="uploader"
                  class="full-width"
                  text-color="white"
                  :max-size="10000000"
                  accept=".pdf"
                  bordered
                  label="[ไฟล์ pdf ขนาดไม่เกิน 10MB]"
                  @added="(v:any) => (fileUpload = v[0])"
                >
                  <template v-slot:header="scope">
                    <div class="row no-wrap items-center q-pa-sm q-gutter-xs">
                      <q-btn
                        v-if="scope.queuedFiles.length > 0"
                        icon="clear_all"
                        @click="scope.removeQueuedFiles"
                        round
                        dense
                        flat
                      >
                        <q-tooltip>ลบทั้งหมด</q-tooltip>
                      </q-btn>
                      <q-btn
                        v-if="scope.uploadedFiles.length > 0"
                        icon="done_all"
                        @click="scope.removeUploadedFiles"
                        round
                        dense
                        flat
                      >
                        <q-tooltip>ลบไฟล์ที่อัปโหลด</q-tooltip>
                      </q-btn>
                      <q-spinner
                        v-if="scope.isUploading"
                        class="q-uploader__spinner"
                      />
                      <div class="col">
                        <div class="q-uploader__title">
                          {{ "[ไฟล์ .pdf ขนาดไม่เกิน 10MB]" }}
                        </div>
                        <div class="q-uploader__subtitle">
                          {{ scope.uploadSizeLabel }} /
                          {{ scope.uploadProgressLabel }}
                        </div>
                      </div>
                      <q-btn
                        v-if="scope.canAddFiles"
                        type="a"
                        icon="add_box"
                        @click="scope.pickFiles"
                        round
                        dense
                        flat
                      >
                        <q-uploader-add-trigger />
                        <q-tooltip>เลือกไฟล์</q-tooltip>
                      </q-btn>
                      <q-btn
                        v-if="scope.isUploading"
                        icon="clear"
                        @click="scope.abort"
                        round
                        dense
                        flat
                      >
                        <q-tooltip>ยกเลิกการอัปโหลด</q-tooltip>
                      </q-btn>
                    </div>
                  </template>
                </q-uploader>

                <q-list bordered dense separator v-else class="full-width">
                  <q-item>
                    <q-item-section> {{ fileData?.fileName }}</q-item-section>
                    <q-item-section avatar>
                      <div class="row">
                        <q-btn
                          flat
                          round
                          color="primary"
                          icon="mdi-download"
                          @click="onDownloadFile(id)"
                        />

                        <q-btn
                          flat
                          round
                          color="grey"
                          icon="close"
                          @click="isUpload = false"
                        />
                      </div>
                    </q-item-section>
                  </q-item>
                </q-list>
              </div>
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right">
          <q-btn label="บันทึก" id="onSubmit" type="submit" color="public">
            <q-tooltip>บันทึกข้อมูล</q-tooltip>
          </q-btn>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>

  <DialogHistory
    v-model:modal="modalHistory"
    :title="`ประวัติแก้ไขปฏิบัติราชการพิเศษ`"
    :columns="columnsHistory"
    :visible-columns="visibleColumnsHistory"
    :fetch-data="fetchDataHistory"
  />
</template>

<style scoped></style>
